{{-------------------------------------------------------------------------------
Book_PASM_SPIN LEDs.SPIN 
Function of program
A variable set in SPIN affects the PASM program
Blinks two LEDs, one in SPIN one in PASM
SPIN code specifies rate for both LEDs.
Connections are as follows:

LEDs connect to lines 0 and 1.

Program         Book_PASM_SPIN LEDs.SPIN
Book            PASM for beginners, Propeller 102
Section         Outputs
Programmer      Harprit Sandhu
Date            Dec 21 2012

Revisions:      Report errors to harprit.sandhu@gmail.com

--------------------------------------------------------------------------------}}
CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
   
OBJ 
  fds : "FullDuplexSerial"   'for communications with PST

VAR
  long  Shared [2]           'declaring it makes it available to all cogs

PUB Go                       '
dira[0]~~                    'for this Cog pin 0 is an output  
cognew(@newCog, @Shared)     'start new Cog and reference shared
shared[0]:=2                 'set the value of shared0 to 2     
shared[1]:=800_0000          'set the value of shared1 to 80_000 used in pasm
  repeat                     '
    !outa[0]                       'invert line 0
    waitcnt(clkfreq/shared[0]+cnt) 'wait
    
'----------------------------
DAT       Org     0
newCog    mov     dira,     pins_set 'sets up first 8 line I/O
          mov     mem,      par      'get base address from par
          add     mem,      #4       'add 4 to get second long
          rdlong  delay,    mem      'read second long (was written in SPIN)
                             
:loop     or      outa,     pins     'turn pin 1 on
          call    #pause             'call pause subroutine
          andn    outa,     pins     'turn pin 1 off
          call    #pause             'call pause subroutine 
          jmp     #:loop             'loop again 
'subroutine 
'======================== 
pause     mov     time,     delay    'the delay subroutine
          add     time,     #9       'const added to skip underflow of CNT                                                                          
delay_loop
          sub      time,    #1 wz              'sub 1 from time and set flag if 0
          if_nz     jmp      #delay_loop       'if flag not 0 do again
pause_ret          ret
'========================
'constants and variables
pins_set   long %00000000_11111111_00000000_00000011 'sets OUTA
pins       long %00000000_10101010_00000000_00000010 'mask using OR and ANDD

mem        res    1
time       res    1
delay      res    1
Fit