{{-------------------------------------------------------------------------------
PASM_BookCounter.SPIN
Function of program
Displays the system counter reading on the PST
Very fast

Connections are as follows:  NONE


Program         PASM_BookCounter.SPIN
Book            PASM for beginners, Propeller 102
Section         Outputs
Programmer      Harprit Sandhu   
Date            Jun 10 2012

Revisions:      Report errors to harprit.sandhu@gmail.com

-------------------------------------------------------------------------------}}
CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

VAR
   long sharedVariable

OBJ
   fds: "FullDuplexSerial"
   
PUB CogZero                             'displays values on console
    fds.start(31,30,0,115200)           'start console at 115200 for debug output
    cognew(@SecondCog, @SharedVariable) 'start the second Cog in PASM
    waitcnt(clkfreq/20+cnt)         'wait sec for everything to stabilize.

    repeat                         'loop
      fds.tx($1)                   'home to 0,0
      fds.dec(SharedVariable)      'display first value
      fds.tx(" ")                  'print space
      waitcnt(clkfreq/60+cnt)      'wait at end of routine,

DAT  org 0                         'the PASM code starts here {counter program}
SecondCog
          mov     temp,     #0     'set counter register to 0
          mov     mem,      par    'get address for PAR register into mem
loop      add     temp,     #1     'add 1 to counter register named temp
          wrlong  temp,     mem    'write to PAR to share it as SharedVariable
          jmp     #loop            'do it again

'constants to be used in the program are listed here like this
SomeConst       long    %00000000_00000000_00000000_00000000 
                        'shown here with value of 0 but not used in this program
'===============================
'variables used in the program are listed here like this
temp    res   1       'space for the variable called temp
mem     res   1       'space for the mem variable
fit
