{{-------------------------------------------------------------------------------
PASM_BookTestFiles123.SPIN 
Function of program
Three objects write three variables to HUB memory
SPIN code reads and displays the values.
Other Objects are TestFile2 and TestFile3
Uses PST to display data, Header and three items

Connections are as follows
None

Program         PASM_BookTestFiles123.SPIN
Book            PASM for beginners, Propeller 102
Section         Outputs
Programmer      Harprit Sandhu   
Date            Feb 10 2013

Revisions:      Report errors to harprit.sandhu@gmail.com

-------------------------------------------------------------------------------}}
CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
  bits = 32
  Vars = 3
  
VAR
  long P_Val[4]
  byte  pot_sub
  
OBJ
  fds : "FullDuplexSerial"
  TF2 : "TestFile2"
  TF3 : "TestFile3"

PUB Go|clear
fds.start(31,30,0,115200)             'start console at 115200 for debug output
main                                  'call main
waitcnt(clkfreq/4 +cnt)               'wait for all to start up
  repeat                              'endless loop
    pot_sub:=0                        'reset id of pot to be printed
    fds.tx($1)                        'home to 0,0
    fds.str(string("Display results"))    'header  
    fds.tx($d)                        'new line  
    fds.tx($d)                        'new line
    repeat Vars                       'loop to display data
      fds.bin(P_val[pot_sub], bits)   'print to the PST in binary
      fds.str(string("   "))          'two spaces to erase old data overflow
      fds.dec(P_val[pot_sub])         'print value as decimal value   
      fds.str(string("   "))          'two spaces to erase old data overflow                                         
      fds.dec(pot_sub)                'print value as decimal value
      fds.str(string("   "))          'three spaces to erase old data overflow
      pot_sub:=(pot_sub)+1            'increment display counter  
      fds.tx($d)                      'new line
    waitcnt(clkfreq/60+cnt)           'flicker free wait  
    clear:=clear+1       'increment counter.    This routine clears up screen
    if clear>10          'decision point        by erasing extra lines of bot
      fds.tx(16)         'clear screen          of PST display every 10 loops
      clear:=0           'reset counter         Only really needed once.

PUB Main  
  Cog1(@P_Val)      'call Cog1
  Cog2(@P_Val)      'call Cog2
  Cog3(@P_Val)      'call Cog3

PUB Cog1(address)                   'Pass address
  cognew(@Cog_1, address)           'use address to start Cog

PUB Cog2(address)
  cognew(@Cog_2, address)

PUB Cog3(address)
  cognew(@Cog_3, address)
  
DAT           org       0
Cog_1
loop          mov       mem,       par      'Read Par
              wrlong    one,       mem      'Write long
              jmp       #loop               'repeat
'constants and variables
one           long      111
mem           res       1
fit
 '=========================
             org       0
Cog_2 
              mov       mem2,      par      'Read Par
              add       mem2,      #4       'add 4 to address
loop2         wrlong    two,       mem2     'Write long  
              jmp       #loop2              'repeat 
'constants and variables
two           long      222
mem2          res       1
fit
 '=========================
              org       0
Cog_3 
loop3         mov       mem3,      par        'Read Par             
              add       mem3,      #8         'add 8 to address     
              wrlong    three,     mem3       'Write long           
              jmp       #loop3                'repeat               
'constants and variables                                            
three         long      333
mem3          res       1
fit
