{{                          starts comments
Program to display incrementing number on PASM
000_PASM_Counter            program name
Harprit Sandhu              author 
05 Nov 11                   date
Propeller 102               book ref
Section 3                   Section ref
3-70                        page ref
}}                         'ends comments

CON
  _clkmode = xtal1 + pll16x    'use a 16x multiplier for the crystal speed
  _xinfreq = 5_000_000         'speed of crystal being used

VAR
    long sh_Var                'the shared variable is declared

OBJ
   fds: "FullDuplexSerial"     'we will be using this Object in our programs
   
PUB CogZero|x                      'displays values on console, x is local var
    fds.start(31,30,0,115200)      'start PST console at 115200 for output 
    cognew(@Cog_1, @Sh_Var)        'start the second Cog_1 in PASM
    waitcnt(clkfreq/20+cnt)        'wait 1/20 for everything to stabilize.
    repeat                         'loop to display value   
      fds.tx($1)                   'home
      fds.str(string("Counter"))   'heading 
      fds.tx($d)                   'new line
      fds.dec(Sh_Var)              'display first value
      fds.str(string("   "))       'print spaces
      waitcnt(clkfreq/60+cnt)      'flicker free wait
      x:=x+1          'increment counter. (This routine clears up the screen    )
      if x>100        'decision point     (by erasing extraneous lines of       )
        fds.tx(16)    'clear screen       (bottom of PST display every 100 loops)
        x:=0          'reset counter      (needed only once in most cases.      )

DAT  org 0                         'the PASM code starts here
{this is the counter program}
Cog_1                              'the second Cog
          mov     count_reg, #0    'set counter register to 0 
          mov     mem,      par    'put address for PAR register into mem
loop      add     count_reg, #1    'add 1 to counter register
          wrlong  count_reg, mem   'write reg to PAR to share it as Sh_Var in SPIN
          jmp     #loop            'do it again

'constants used in the program are listed like this
SomeConst       long    %00000000_00000000_00000000_00000000   
               'not used in program but shown as an example here

'variables used in the program are listed like this
count_reg  res 1         'the register we are manipulating
mem        res 1         'the location of PAR
Fit                      'check that program will fit in cog.

================================================================================
================================================================================
