{{------------------------------------------------------------------------------
Book_7 Seg Displ.SPIN 
Function of program
The programs displays the numbers form 0 to 9 on a seven segment display.
All LEDs for a digit are displayed at the same time.  They are not scanned.  
The decimal point is ignored.
Uses a common anode display.

Program         Book_7 Seg Displ.SPIN 
Book            PASM for beginners, Propeller 102
Section         3 Inputs
Programmer      Harprit Sandhu   
Date            Dec 21 2012

Revisions:      Report errors to harprit.sandhu@gmail.com

-------------------------------------------------------------------------------}}
CON
  _clkmode = XTAL1 + PLL16x
  _xinfreq = 5_000_000
   Pin_1 = 1         'Display connections
   Pin_2 = 2         'segments to pins
   Pin_3 = 3         'are definer here
   Pin_4 = 4         'for later assignement
   Pin_5 = 5         'to segments.
   Pin_6 = 6
   Pin_7 = 7
  
PUB Main  
cognew(@PCog, 0)              'Cog in PASM for 7 Seg display 
  repeat 

'
DAT
          org     0                   'start at 0 location in the Cog 
PCog
:loop     mov     select,   num0      'load the number pattern into select
          call    #display            'display whatever is in select
          mov     select,   num1 
          call    #display         
          mov     select,   num2 
          call    #display  
          mov     select,   num3 
          call    #display  
          mov     select,   num4 
          call    #display
          mov     select,   num5 
          call    #display  
          mov     select,   num6 
          call    #display  
          mov     select,   num7 
          call    #display  
          mov     select,   num8 
          call    #display  
          mov     select,   num9 
          call    #display 
          jmp     #:loop               'go do it again

display                               'start point identification
          mov     dira,     setdira   'set pin I/O
          shl     select,   #1        'we are not using pin 0 so move over
          mov     outa,     select    'turn on relevant pins
          call    #delay              'delay between number updates 
display_ret ret                       'return

delay     mov     del_time,  delay_long      'set delay
:loop     djnz    del_time,  #:loop          'decrement and jump
delay_ret ret                                'return

'constants and variables 
delay_long  long    50_000_00
SetDira     long    %00000000_00000000_00000000_11111110

'segment connections to pins (assignment)
Seg_1  long  1<<Pin_4  
Seg_2  long  1<<Pin_2  
Seg_3  long  1<<Pin_1  
Seg_4  long  1<<Pin_3  
Seg_5  long  1<<Pin_6  
Seg_6  long  1<<Pin_7  
Seg_7  long  1<<Pin_5  

'number design  
num0   long   %001_00_00
num1   long   %111_10_01
num2   long   %010_00_10
num3   long   %010_10_00        'note:
num4   long   %100_10_01        'these are for a common
num5   long   %000_11_00        'anode display
num6   long   %000_01_00
num7   long   %111_10_00
num8   long   %000_00_00
num9   long   %000_10_00
null   long   %111_11_11

del_time   res  1
select     res  1
Fit
