{{------------------------------------------------------------------------------
Book_7 Seg Displ2.SPIN 
Function of program
The programs displays the numbers form 0 to 9 on a seven segment display.
All LEDs for a digit are displayed at the same time.  They are not scanned.
The decimal point is ignored.
Uses a common anode display.

Program         Book_7 Seg Displ2.SPIN
Book            PASM for beginners, Propeller 102
Section         3 Inputs
Programmer      Harprit Sandhu   
Date            Dec 21 2012

Revisions:      Report errors to harprit.sandhu@gmail.com

-------------------------------------------------------------------------------}}

CON
  _clkmode = XTAL1 + PLL16x
  _xinfreq = 5_000_000
   Pin_1 = 1         'Display connections
   Pin_2 = 2         'segments to pins
   Pin_3 = 3         'are definer here
   Pin_4 = 4         'for later assignment
   Pin_5 = 5         'to segments.
   Pin_6 = 6
   Pin_7 = 7
   pin_8=8

VAR
  long var1
  
PUB Main 
cognew(@PCog, @var1)          'Cog in PASM for 7 Seg display
  repeat 

DAT       org     0                     'start at 0 location in the Cog
PCog      mov     dira,     setdira     'set pin I/O
:loop     mov     select,   num0        'load the number pattern into select
          call    #display              'display the digit 0
          mov     select,   num1        'select number bits to set
          call    #display              'display the digit 1
          mov     select,   num2        'select number bits to set
          call    #display              'display the digit 2
          mov     select,   num3        'select number bits to set
          call    #display              'display the digit 3
          mov     select,   num4        'select number bits to set
          call    #display              'display the digit 4
          mov     select,   num5        'select number bits to set
          call    #display              'display the digit 5
          mov     select,   num6        'select number bits to set
          call    #display              'display the digit 6
          mov     select,   num7        'select number bits to set
          call    #display              'display the digit 7
          mov     select,   num8        'select number bits to set
          call    #display              'display the digit 8
          mov     select,   num9        'select number bits to set
          call    #display              'display the digit 9
          mov     select,   null        'select number bits to set
          call    #display              'display a blank
          jmp     #:loop                'go do it again
'=========================
display   shl     select,   #1          'Shift left to skip bit 0 
          mov     outerC,   dispX       'set number of times to display segments
loop1     mov     maskC,    mask        'make copy of mask
          mov     nmbr,     #8          'loop for segments
loop2     mov     temp,     select      'we are not using point 0 so move over
          or      temp,     maskC       'mask to identify bit to display
          mov     outa,     temp        'display bit
          mov     temp,     select      'reload number data'
          SHL     maskC,    #1          'shift mask left
          add     maskC,    #1          'convert 0 in bit0 to 1
          sub     nmbr,     #1  wz      'decrement bit count, set zero flag
if_NZ     jmp     #loop2                'do again if not zero
          sub     outerC,   #1  wz      'decrement outer loop
if_NZ     jmp     #loop1                'do again if not zero
          CALL    #delay                'delay between digits displayed
display_ret ret                         'return

'==========================
delay     mov     del_time,  delay1    'set delay
:loop     djnz    del_time,  #:loop     'decrement and jump
delay_ret         ret                   'return
'==========================
'constants and variables 
delay1    long    5000000
SetDira   long    %00000000_00000000_00000000_11111111
mask      long    %11111111_11111111_11111111_11111101
dispX     long    80000
'=======================
'segment connections to pins (assignment)
Seg_1  long  1<<Pin_1     
Seg_2  long  1<<Pin_2     
Seg_3  long  1<<Pin_3        'this is where we wire up the connection
Seg_4  long  1<<Pin_4        'correct for cross connections
Seg_5  long  1<<Pin_5        'create numbers 
Seg_6  long  1<<Pin_6        
Seg_7  long  1<<Pin_7     
Seg_8  long  1<<Pin_8         'not used in this program

'number pattern bit settings  
num0   long   %000_01_00
num1   long   %001_11_11
num2   long   %010_00_10
num3   long   %110_00_00        'note:
num4   long   %101_00_01        'these are addresses for a common
num5   long   %100_10_00        'anode display
num6   long   %000_10_00
num7   long   %110_01_01
num8   long   %000_00_00
num9   long   %100_00_00
null   long   %111_11_11    

del_time  res  1
select    res  1
nmbr      res  1
temp      res  1
aterC     res  1
maskC     res  1
outerC    res  1
Fit
