{{-------------------------------------------------------------------------------                                                                                      
Book_PASM_PWM.SPIN
Function of program
Pule width modulated signal generation.

Notes:  Program reads a potentiometer and uses its value to
to mudulate the wave langth of the signal.
An MCP 3208 is installed at pins 24..27. Speaker is on line 0
Also used lines 0 and 1 to read and generate signals.
Ues Oscilloscope 
See details in book

Program         Book_PASM_PWM.SPIN
Book            PASM for beginners, Propeller 102
Section         Outputs
Programmer      Harprit Sandhu   
Date            Jan 10 2013

Revisions:      Report errors to harprit.sandhu@gmail.com

-------------------------------------------------------------------------------}}
CON
  _clkmode = XTAL1 + PLL16x
  _xinfreq = 5_000_000

VAR
  long  P_Val[4]   
   
OBJ 
  fds : "FullDuplexSerial"          'for communications with PST  
  r4p : "read4pots"                 'reads pots
  
PUB Main|x 
fds.start(31,30,0,115200)           'start console at 115200 for debug output  
r4p.Read4Pots(@P_Val)  'start pot reading loop in read4pots object, start first 
cognew(@PWM, @P_Val)         'Cog in PASM for freq gen  
fds.tx(1)                    'clear screen
repeat         
  fds.tx(1)                'home
  fds.dec(P_Val[0])        'print pot0 value
  fds.tx(" ")              'space
  fds.tx($d)               'next line

  waitcnt(clkfreq/60+cnt)  'flicker free wait
  x:=x+1                   'increment counter. This routine clears up screen
  if x>100                 'decision point     by erasing extra lines of bot
    fds.tx(16)             'clear screen       of PST display every 100 loops
    x:=0                   'reset counter
'-------------------------------------------------------------------------------- 

DAT       org 0
PWM       mov       dira,       set_dira_M      'set dira register
          mov      ctra,        counter_image   'set counter
          mov      mem,         par             'read par
          mov      frqa,        #1              'set frqa
          mov      period,      cnt             'read counter
          add      period,      #180            'add to prevent overflow
:loop     mov      verb,        #0              'reset pulse width min
          rdlong   pot0,        mem             'read potentiometer 0
          subs     verb,        pot0            'determine pulse
          subs     verb,        #60             'add 60 for compensation
          mov      phsa,        verb            'set phase
          add      period,      wav1            'add to counter for next wave end
          waitcnt  period,      wav1            'wait for end of wave
          jmp      #:Loop                       'loop back
'================================================================================
'Constants and variables 
set_dira_M        long    %00000000_00000000_00000000_00000001
counter_image     long    %00010000_00000000_00000000_00000000
wav1              long    2200

verb              long    0 
period            res     1
pot0              res     1
mem               res     1
Fit
