{{-------------------------------------------------------------------------------
Book_PASM_Read_Keybd.SPIN
Function of program
This programs demonstrates how to read a simple keyboard
that uses a common ground for all its keys.

Notes:  Uses a keyboard available from "All electronics".

Program         Book_PASM_Read_Keybd.SPIN
Book            PASM for beginners, Propeller 102
Section         3 Outputs
Programmer      Harprit Sandhu   
Date            Jan 20 2013

Revisions:      Report errors to harprit.sandhu@gmail.com

--------------------------------------------------------------------------------}}
CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000


OBJ 
  fds : "FullDuplexSerial"         'for communications with PST
  
VAR
  long P_Val[2]           'we need only one variable
  byte subsc              'subscripts for P_Val
   
PUB Main|x  
fds.start(31,30,0,115200)         'start console at 115200 for debug output 
waitcnt(clkfreq/60+cnt)            'flicker free wait
Cognew(@Key_Bd,   @P_Val)         'start PASM program 
waitcnt(clkfreq/60 +cnt)          'wait for cogs to strartup
'dira[0]~                         'set I/O for pins used '
'dira[1]~~                        'set I/O for pins used 
fds.tx($16)                       'clear screen
  repeat                          ' 
    fds.tx($1)                    'new line  
    fds.str(string("Button status")) 'print to display 
    fds.tx($d)
    fds.bin(P_Val[0],12)             'print pot0 value
    fds.str(string("     "))         'space  
    fds.tx($d)                       'next line 
    
    waitcnt(clkfreq/60+cnt)   'flicker free wait
    x:=x+1        'increment counter. (This routine clears up the screen    )
    if x>100      'decision point     (by erasing extraneous lines at the   )
      fds.tx(16)  'clear screen       (bottom of PST display every 100 loops)
      x:=0        'reset counter      (needed only once in most cases.      )

'=============  End of Cog 0, the PST display Cog =============

DAT  org  0
Key_Bd    mov     dira,   dira_set0   'sets direction of the prop pins
          mov     mem,    par         'set mem from PAR
          mov     mem1,   mem         'set mem1
          add     mem1,   #4
was12     mov     pin_ID, #0

all_up    mov     temp,   ina         'read all inputs
          andn    temp,   select      'ignores high 20 bits
          sub     temp,   all_pins wz 'look at pin 0  
   if_z   jmp     #all_up             'if still high look again
 
not0      mov     temp,   ina         'store counter as soon as low  
          wrlong  temp,   mem         'write to mem
          andn    temp,   mask0 wz    'look at bit0 
   if_nz  jmp     #not0               'if it was not zero
 
          wrlong  pin_ID, mem1        'write it mem1
          shr     temp,   #1          'shift to next position
          add     pin_ID, #1          'increment pin ID number
          mov     temp2,  pin_ID      'store count in temp
          sub     temp2,  #12   wz    'subtract 12
    if_z  jmp     #not0               'do next bit if not zero
          jmp     #was12              'if it was not do it all over

:hold     jmp     #:hold              'safety stop never executed
'==========constants and variables=========
dira_set0      long      %00000000_00000000_00000000_00000000 'Set dira register                                                                              
mask0          long      %11111111_11111111_11111111_11111110
all_pins       long      %00000000_00000000_00001111_11111111
select         long      %11111111_11111111_1111000_000000000
pins           long      12

mem            res       1          'memory location for PAR
mem1           res       1
Pin_ID         res       1
temp           res       1
temp2           res      1
Fit
