{{
program to call and display 4 potentiometers
read from external object "Read4Pots"
}}
CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
  Vars = 32                We only need 4 for the potentiometers but 32 is OK
  
VAR
  long  stack1[25]
  long P_Val[32]
  byte  subscr
  
OBJ
  fds : "FullDuplexSerial"
  r4p : "Read4Pots"
  
PUB Go|x 
fds.start(31,30,0,115200)           'start PST console at 115200 for output 
r4p.Read4Pots(@P_Val) (THE LINE THAT READS THE 4 POTS)
repeat subscr from 0 to vars
  P_Val[subscr]:=0                   'set all variables to 0                                                                                     
repeat 
   fds.tx(16)                            'clear screen
   fds.str(string("Display results"))    'heading                                                                                              
   fds.str(string("  "))           'two spaces to erase old data overflow  
   fds.tx(1)                       'home 
   fds.tx($d)                      'new line 
   fds.tx($d)                      'new line  
   repeat subscr from 0 to vars   'loop to display all available variables                                                                  
     fds.bin(P_Val[subscr], 12)    'print to the PST in binary                                                                                                               
     fds.str(string("   "))       'two spaces to erase old data overflow                                                                                                       
     fds.dec(subscr)              'print value as decimal value                                                                                                                
     fds.str(string("   "))       'three spaces to erase old data overflow                                                                                                                  
     fds.tx($d)
                                                                                                                                                      
   waitcnt(clkfreq/60+cnt)         'wait 
   x:=x+1      'increment counter. (This routine clears up the screen    )
   if x>100    'decision point     (by erasing extraneous lines of       )
     fds.tx(16)'clear screen       (bottom of PST display every 100 loops)
     x:=0      'reset counter      (Needed only once in most cases.      )
