Page 198
loop      call    #wait_lo              'wait for signal to go low
          call    #wait_Hi              'wait for signal to go high
          mov     temp,     cnt         '
          wrlong  temp,     mem         '1st high
          
          call    #wait_lo              '
          mov     temp2,    cnt         '1st low
          wrlong  temp2,    mem1        '
  
          sub     temp2,    temp        'subtract the two
          wrlong  temp2,    mem2        'length of high

          call    #wait_Hi
          mov     temp3,    cnt         '2nd high completes wavelength
          wrlong  temp3,    mem3        '

          rdlong  temp2,    mem1        '
          sub     temp3,    temp2       'subtract for length of low
          wrlong  temp3,    mem4        'length of low
          mov     temp4,    temp3       '
          shr     temp4,    #3          'divide by 8 for use by servo (Scaling)
          call    #wait60               'wait 1/60 seconds
          call    #send_p               'send out pulse to position servo                                       
          jmp     #loop                 'go back and do it again.

wait_Lo   mov     inbits,   ina         'wait for pin to go lo
          andn    inbits,   mask23  wz
if_nz     jmp     #wait_lo
Wait_Lo_ret       ret
'=====================================
wait_Hi   mov     inbits,   ina         'wait for pin to go hi
          andn    inbits,   mask23  wz
if_z      jmp     #wait_hi
Wait_Hi_ret       ret
'=====================================
wait60    mov delay, sixty               'wait for 1/60 secs
:loop     djnz  delay, :loop
wait60_ret        ret
'=====================================
send_P                                    'reads data set in SPIN
          or      outa,     Pin1          'pin high
          rdlong  short,    mem6          'read data
:loop     djnz short,       :loop         'wait for data read to do by
          andn    outa,     Pin1          'pin low
send_P_ret       ret
'=====================================

The constants and variables are defined as follows:

middle    long    31500        'middle position for servo
delay1    long    -17500       'correction for output pulse
sixty     long    100_000_     'long delay not critical
Set_dira  long    %00000000_00000000_00000000_00000011
mask23    long    %11111111_01111111_11111111_11111111
pin23     long    %11111111_11111111_11111111_11111110
Pin1      long    %00000000_00000000_00000000_00000001

mem       res   1
mem1      res   1
mem2      res   1
mem3      res   1
mem4      res   1
mem5      res   1
mem6      res   1
temp      res   1
temp2     res   1
temp3     res   1
temp4     res   1
inbits    res   1
delay     res   1
short     res   1