{{------------------------------------------------------------------------------
Book_PASM_440 Tone.SPIN.
Function of program
Generate fixed 440 cps tone on line 1.
Part of Metronome project 

Program         Book_PASM_440 Tone.SPIN.
Book            PASM for beginners, Propeller 102
Section         Projects
Programmer      Harprit Sandhu   
Date            Jan 10 2013

Revisions:      Report errors to      harprit.sandhu@gmail.com
                                                                            
-------------------------------------------------------------------------------}}
CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
  
PUB Main | P_Val                    'P_VaL is a local variable here
cognew(@B440, @P_Val)               'start new cog at "beat"
waitcnt(clkfreq/60 +cnt)            'pause for everything to start up
  repeat                            'park loop

DAT       Org     0                   'set origin
B440      mov     dira,   set_dira    'set direction for lines as inputs
          mov     temp,   CNT         'read counter
          add     temp,   #24         'add delay for loop

loop      mov     mem,    par         'read the PAR register
          mov     outa,   state_Lo    'clear line
          call    #wait1              'timing wait
          mov     outa,   state_Hi    'accurate hi to lo edge 
          call    #wait1              'timing wait
          wrlong  delay,  mem         'store delay in HUB memory
          jmp     #loop               'go back and do it again.
'==================
'subroutines
wait1     waitcnt temp,   delay       'load delay in temp var
wait1_ret         ret                  'return from subroutine
'==================
'constants
Set_dira     long   %00000000_00000000_00000000_00000001
state_Hi     long   %00000000_00000000_00000000_00000001
state_Lo     long   %00000000_00000000_00000000_00000000
delay        long   90_909
'variables
mem       res 1
temp      res 1
Fit 
