{{------------------------------------------------------------------------------
Book_PASM_FirstChirp.SPIN
Function of program
First program development to show chirps and delays between them.
This program is developped further in book to get to a Metronome

Program         Book_PASM_FirstChirp.SPIN 
Book            PASM for beginners, Propeller 102
Section         Projects
Programmer      Harprit Sandhu   
Date            Jan 10 2013

Revisions:      Report errors to harprit.sandhu@gmail.com

-------------------------------------------------------------------------------}}
CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
  
PUB Main | P_Val                    'P_VaL is a local variable here
cognew(@Beat, @P_Val)               'start new cog at "beat"
waitcnt(clkfreq/60 +cnt)             'pause for everything to start up
  repeat                            'park loop

DAT     org 0                             'sets the starting point in Cog
Beat    mov       delay,     cnt          'read in CNT
        add       delay,     #100         'add to skip counter rollover
        mov       dira,      set_dira     'sets direction of the prop pins
loop1   mov       count,     #8           'chirp counter
        mov       Delta,     wait_const   'set delta   

loop    andn      outa,      test_bit     'make bit high
        waitcnt   delay,     delta        'pause
        or        outa,      test_bit     'make bit low
        waitcnt   delay,     delta        'delay
        sub       count,     #1   wz      'subtract from counter
if_nz   jmp       #loop                   'loop back

        mov       delta,     wait_const2  'load longer delay
        andn      outa,      test_bit     'make bit low
        waitcnt   delay,     delta        'make long delay
        jmp       #loop1                  'back to top
                            
set_dira      long      %00001011_00000000_00000000_00000010   'Sets dira 
test_bit      long      %00000000_00000000_00000000_00000010   'toggled bit
wait_const    long      10000            'short delay
wait_const2   long      500000           'long delay
clk_speed     long      80_000_000       'clock 

count          res      1     'memory location for PAR variable 
delay          res      1     'delay constant for CNT
delta          res      1     'interval between changes of signal
